#ifndef _RAWIO_H
#define _RAWIO_H

#include <sys/reent.h>
#include <sys/stat.h>

#include "common.h"
#include "rawpartition.h"


typedef struct {
	int fd;
	u32 partitionSize;
	u32 currentPosition;
	u32 partitionStartOffset;
	bool read;
	bool write;
	bool append;
// 	bool inUse;
	RAWPARTITION* partition;
} RAWIO_STRUCT;


extern int _RAWIO_open_r (struct _reent *r, void *fileStruct, const char *path, int flags, int mode);

extern int _RAWIO_close_r (struct _reent *r, int fd);

extern int _RAWIO_write_r (struct _reent *r,int fd, const char *ptr, int len);

extern int _RAWIO_read_r (struct _reent *r, int fd, char *ptr, int len);

extern int _RAWIO_seek_r (struct _reent *r, int fd,int pos, int dir);

extern int _RAWIO_fstat_r (struct _reent *r, int fd, struct stat *st);

extern int _RAWIO_stat_r (struct _reent *r, const char *path, struct stat *st);

extern int _RAWIO_link_r (struct _reent *r, const char *existing, const char *newLink);

extern int _RAWIO_unlink_r (struct _reent *r, const char *path);

extern int _RAWIO_chdir_r (struct _reent *r, const char *path);
	
#endif // _RAWIO_H
